/*=============================================================================

    This file is part of FLINT.

    FLINT is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FLINT is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FLINT; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

=============================================================================*/
/******************************************************************************

    Copyright (C) 2008 Peter Shrimpton
    Copyright (C) 2009 William Hart
   
******************************************************************************/

#include <mpir.h>
#include "flint.h"
#include "ulong_extras.h"

int
n_is_probabprime_fermat(mp_limb_t n, mp_limb_t i)
{
    if (FLINT_BIT_COUNT(n) <= FLINT_D_BITS)
        return (n_powmod(i, n - 1, n) == 1UL);
    else
    {
        if ((mp_limb_signed_t) (n - 1) < 0L)
        {
            mp_limb_t temp = n_powmod2(i, (n - 1) / 2, n);
            return (n_powmod2(temp, 2, n) == 1UL);
        }
        else
        {
            return (n_powmod2(i, n - 1, n) == 1UL);
        }
    }
}
